#ifndef LIGHT_HXX
#define LIGHT_HXX

#include "Vec3f.hxx"
#include "Ray.hxx"

// forward declaration
class Scene;

class Light
{
public:
  Light(Scene* scene);
  virtual ~Light();
  
  virtual bool Illuminate(Ray& shadowray, Vec3f& intensity) = 0;
protected:
  Scene* m_scene;

private:
  Light();
  Light(const Light& );
  Light& operator=(const Light& );
};
#endif
